git: 2d4b1f4b8cf0 - main - stress2: Added a syzkaller reproducer. Enable all reaper tests

From: Peter Holm <pho_at_FreeBSD.org>
Date: Tue, 14 Jun 2022 05:00:06 UTC
The branch main has been updated by pho:

URL: https://cgit.FreeBSD.org/src/commit/?id=2d4b1f4b8cf0d3262d1d7b969711081c50134888

commit 2d4b1f4b8cf0d3262d1d7b969711081c50134888
Author:     Peter Holm <pho@FreeBSD.org>
AuthorDate: 2022-06-14 04:59:32 +0000
Commit:     Peter Holm <pho@FreeBSD.org>
CommitDate: 2022-06-14 04:59:32 +0000

    stress2: Added a syzkaller reproducer.  Enable all reaper tests
---
 tools/test/stress2/misc/all.exclude    |   7 -
 tools/test/stress2/misc/syzkaller58.sh | 290 +++++++++++++++++++++++++++++++++
 2 files changed, 290 insertions(+), 7 deletions(-)

diff --git a/tools/test/stress2/misc/all.exclude b/tools/test/stress2/misc/all.exclude
index 6cd636522c48..ac5576ed1308 100644
--- a/tools/test/stress2/misc/all.exclude
+++ b/tools/test/stress2/misc/all.exclude
@@ -44,11 +44,6 @@ oom2.sh			Hang in pfault							20180324
 overcommit2.sh		CAM stuck in vmwait seen					20200112
 pageout.sh		panic: handle_written_filepage: not started			20190218
 pmc8.sh			panic: [pmc,2749] (ri21, rc1) waiting too long for pmc to ...	20210621
-reaper.sh		Waiting for commit
-reaper2.sh		Waiting for commit
-reaper3.sh		Waiting for commit
-reaper4.sh		Waiting for commit
-reaper5.sh		Waiting for commit
 rename14.sh		https://people.freebsd.org/~pho/stress/log/log0279.txt		20220415
 sctp2.sh		panic: Queues are not empty when handling SHUTDOWN-COMPLETE	20210211
 sctp3.sh		panic: Queues are not empty when handling SHUTDOWN-COMPLETE	20210211
@@ -66,8 +61,6 @@ syzkaller25.sh		WiP								20201116
 syzkaller27.sh		watchdogd fires							20220512
 syzkaller28.sh		WiP								20201120
 syzkaller50.sh		panic: Assertion done != job_total_nbytes failed at ...		20220405
-syzkaller52.sh		Waiting for commit
-syzkaller53.sh		Waiting for commit
 syzkaller54.sh		panic: td 0xfffffe014f7193a0 is not suspended			20220527
 syzkaller55.sh		panic: Counter goes negative					20220525
 timeout.sh		Waiting for commit
diff --git a/tools/test/stress2/misc/syzkaller58.sh b/tools/test/stress2/misc/syzkaller58.sh
new file mode 100755
index 000000000000..0083e13f1692
--- /dev/null
+++ b/tools/test/stress2/misc/syzkaller58.sh
@@ -0,0 +1,290 @@
+#!/bin/sh
+
+# panic: td 0xfffffe010e6ff000 is not suspended
+# cpuid = 2
+# time = 1654661460
+# KDB: stack backtrace:
+# db_trace_self_wrapper() at db_trace_self_wrapper+0x2b/frame 0xfffffe0143924c10
+# vpanic() at vpanic+0x17f/frame 0xfffffe0143924c60
+# panic() at panic+0x43/frame 0xfffffe0143924cc0
+# thread_single() at thread_single+0x736/frame 0xfffffe0143924d40
+# fork1() at fork1+0x1e1/frame 0xfffffe0143924da0
+# sys_rfork() at sys_rfork+0xa4/frame 0xfffffe0143924e00
+# amd64_syscall() at amd64_syscall+0x145/frame 0xfffffe0143924f30
+# fast_syscall_common() at fast_syscall_common+0xf8/frame 0xfffffe0143924f30
+# --- syscall (0, FreeBSD ELF64, nosys), rip = 0x821be4d1a, rsp = 0x8276b8f48, rbp = 0x8276b8f70 ---
+# KDB: enter: panic
+# [ thread pid 2860 tid 100362 ]
+# Stopped at      kdb_enter+0x32: movq    $0,0x1277d83(%rip)
+# db> x/s version
+# FreeBSD 14.0-CURRENT #0 reap-n255837-0bdda1ded8d: Thu May 26 22:38:04 CEST 2022
+# pho@mercat1.netperf.freebsd.org:/var/tmp/deviant3/sys/amd64/compile/PHO
+# db> 
+
+# Submitted by:	 markj
+
+[ `uname -p` != "amd64" ] && exit 0
+
+. ../default.cfg
+cat > /tmp/syzkaller58.c <<EOF
+// autogenerated by syzkaller (https://github.com/google/syzkaller)
+
+#define _GNU_SOURCE
+
+#include <sys/types.h>
+
+#include <errno.h>
+#include <pthread.h>
+#include <pwd.h>
+#include <signal.h>
+#include <stdarg.h>
+#include <stdbool.h>
+#include <stdint.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/endian.h>
+#include <sys/syscall.h>
+#include <sys/wait.h>
+#include <time.h>
+#include <unistd.h>
+
+static unsigned long long procid;
+
+static void kill_and_wait(int pid, int* status)
+{
+  kill(pid, SIGKILL);
+  while (waitpid(-1, status, 0) != pid) {
+  }
+}
+
+static void sleep_ms(uint64_t ms)
+{
+  usleep(ms * 1000);
+}
+
+static uint64_t current_time_ms(void)
+{
+  struct timespec ts;
+  if (clock_gettime(CLOCK_MONOTONIC, &ts))
+    exit(1);
+  return (uint64_t)ts.tv_sec * 1000 + (uint64_t)ts.tv_nsec / 1000000;
+}
+
+static void thread_start(void* (*fn)(void*), void* arg)
+{
+  pthread_t th;
+  pthread_attr_t attr;
+  pthread_attr_init(&attr);
+  pthread_attr_setstacksize(&attr, 128 << 10);
+  int i = 0;
+  for (; i < 100; i++) {
+    if (pthread_create(&th, &attr, fn, arg) == 0) {
+      pthread_attr_destroy(&attr);
+      return;
+    }
+    if (errno == EAGAIN) {
+      usleep(50);
+      continue;
+    }
+    break;
+  }
+  exit(1);
+}
+
+typedef struct {
+  pthread_mutex_t mu;
+  pthread_cond_t cv;
+  int state;
+} event_t;
+
+static void event_init(event_t* ev)
+{
+  if (pthread_mutex_init(&ev->mu, 0))
+    exit(1);
+  if (pthread_cond_init(&ev->cv, 0))
+    exit(1);
+  ev->state = 0;
+}
+
+static void event_reset(event_t* ev)
+{
+  ev->state = 0;
+}
+
+static void event_set(event_t* ev)
+{
+  pthread_mutex_lock(&ev->mu);
+  if (ev->state)
+    exit(1);
+  ev->state = 1;
+  pthread_mutex_unlock(&ev->mu);
+  pthread_cond_broadcast(&ev->cv);
+}
+
+static void event_wait(event_t* ev)
+{
+  pthread_mutex_lock(&ev->mu);
+  while (!ev->state)
+    pthread_cond_wait(&ev->cv, &ev->mu);
+  pthread_mutex_unlock(&ev->mu);
+}
+
+static int event_isset(event_t* ev)
+{
+  pthread_mutex_lock(&ev->mu);
+  int res = ev->state;
+  pthread_mutex_unlock(&ev->mu);
+  return res;
+}
+
+static int event_timedwait(event_t* ev, uint64_t timeout)
+{
+  uint64_t start = current_time_ms();
+  uint64_t now = start;
+  pthread_mutex_lock(&ev->mu);
+  for (;;) {
+    if (ev->state)
+      break;
+    uint64_t remain = timeout - (now - start);
+    struct timespec ts;
+    ts.tv_sec = remain / 1000;
+    ts.tv_nsec = (remain % 1000) * 1000 * 1000;
+    pthread_cond_timedwait(&ev->cv, &ev->mu, &ts);
+    now = current_time_ms();
+    if (now - start > timeout)
+      break;
+  }
+  int res = ev->state;
+  pthread_mutex_unlock(&ev->mu);
+  return res;
+}
+
+struct thread_t {
+  int created, call;
+  event_t ready, done;
+};
+
+static struct thread_t threads[16];
+static void execute_call(int call);
+static int running;
+
+static void* thr(void* arg)
+{
+  struct thread_t* th = (struct thread_t*)arg;
+  for (;;) {
+    event_wait(&th->ready);
+    event_reset(&th->ready);
+    execute_call(th->call);
+    __atomic_fetch_sub(&running, 1, __ATOMIC_RELAXED);
+    event_set(&th->done);
+  }
+  return 0;
+}
+
+static void execute_one(void)
+{
+  int i, call, thread;
+  for (call = 0; call < 5; call++) {
+    for (thread = 0; thread < (int)(sizeof(threads) / sizeof(threads[0]));
+         thread++) {
+      struct thread_t* th = &threads[thread];
+      if (!th->created) {
+        th->created = 1;
+        event_init(&th->ready);
+        event_init(&th->done);
+        event_set(&th->done);
+        thread_start(thr, th);
+      }
+      if (!event_isset(&th->done))
+        continue;
+      event_reset(&th->done);
+      th->call = call;
+      __atomic_fetch_add(&running, 1, __ATOMIC_RELAXED);
+      event_set(&th->ready);
+      event_timedwait(&th->done, 50);
+      break;
+    }
+  }
+  for (i = 0; i < 100 && __atomic_load_n(&running, __ATOMIC_RELAXED); i++)
+    sleep_ms(1);
+}
+
+static void execute_one(void);
+
+#define WAIT_FLAGS 0
+
+static void loop(void)
+{
+  int iter = 0;
+  for (;; iter++) {
+    int pid = fork();
+    if (pid < 0)
+      exit(1);
+    if (pid == 0) {
+      execute_one();
+      exit(0);
+    }
+    int status = 0;
+    uint64_t start = current_time_ms();
+    for (;;) {
+      if (waitpid(-1, &status, WNOHANG | WAIT_FLAGS) == pid)
+        break;
+      sleep_ms(1);
+      if (current_time_ms() - start < 5000)
+        continue;
+      kill_and_wait(pid, &status);
+      break;
+    }
+  }
+}
+
+void execute_call(int call)
+{
+  switch (call) {
+  case 0:
+    syscall(SYS_rfork, 0x93000ul);
+    break;
+  case 1:
+    syscall(SYS_kqueue);
+    break;
+  case 2:
+    *(uint32_t*)0x20000000 = 0x1d;
+    *(uint32_t*)0x20000004 = 0;
+    *(uint32_t*)0x20000008 = 0;
+    *(uint32_t*)0x2000000c = 0;
+    *(uint32_t*)0x20000010 = 0;
+    memset((void*)0x20000014, 0, 60);
+    syscall(SYS_procctl, 0ul, 0, 6ul, 0x20000000ul);
+    break;
+  case 3:
+    syscall(SYS_kevent, -1, 0ul, 0ul, 0ul, 0ul, 0ul);
+    break;
+  case 4:
+    syscall(SYS_truncate, 0ul, 4ul);
+    break;
+  }
+}
+int main(void)
+{
+  syscall(SYS_mmap, 0x20000000ul, 0x1000000ul, 7ul, 0x1012ul, -1, 0ul);
+  for (procid = 0; procid < 2; procid++) {
+    if (fork() == 0) {
+      loop();
+    }
+  }
+  sleep(1000000);
+  return 0;
+}
+
+
+EOF
+mycc -o /tmp/syzkaller58 -Wall -Wextra -O0 /tmp/syzkaller58.c -lpthread \
+    || exit 1
+
+(cd /tmp; timeout 3m ./syzkaller58)
+
+rm -rf /tmp/syzkaller58 /tmp/syzkaller58.c /tmp/syzkaller58.core \
+    /tmp/syzkaller.??????
+[ $loaded ] && kldunload sctp.ko
+exit 0